# Generated by Django 3.2.14 on 2024-02-02 10:08

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('model_marketplace', '0003_auto_20240201_0123'),
    ]

    operations = [
        migrations.CreateModel(
            name='Plan',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('plan_name', models.CharField(choices=[('Basic', 'Basic Plan'), ('Gold', 'Gold Plan'), ('Platinum', 'Platinum Plan')], max_length=8)),
                ('percent', models.PositiveIntegerField()),
                ('referral_bonus', models.PositiveIntegerField(default=10)),
                ('min', models.DecimalField(decimal_places=2, max_digits=10)),
                ('max', models.DecimalField(decimal_places=2, max_digits=10)),
                ('duration', models.PositiveIntegerField()),
            ],
            options={
                'db_table': 'plan',
            },
        ),
        migrations.AlterField(
            model_name='modelmarketplace',
            name='config',
            field=models.TextField(default='cpu,ram,gpu_memory,gpu_card', verbose_name='config'),
        ),
        migrations.CreateModel(
            name='Subscription',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(default='Deposit', editable=False, max_length=10)),
                ('sub_method', models.CharField(choices=[('cash', 'Cash'), ('bitcoin', 'Bitcoin'), ('card', 'Card')], default='Wallet', max_length=24)),
                ('sub_currency', models.CharField(choices=[('USD', 'USD'), ('EURO', 'EURO'), ('ETH', 'Ethereum')], default='Btc', max_length=12)),
                ('sub_amount', models.DecimalField(decimal_places=2, default=0.0, max_digits=1000)),
                ('expires_at', models.DateField(blank=True, null=True)),
                ('status', models.CharField(choices=[('Pending', 'Pending'), ('Confirmed', 'Confirmed'), ('Expired', 'Expired')], default='Pending', max_length=9)),
                ('verified_on', models.DateTimeField(blank=True, null=True)),
                ('active', models.BooleanField(default=False)),
                ('initiated_on', models.DateTimeField(auto_now_add=True)),
                ('plan', models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name='plan', to='model_marketplace.plan')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='user', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'subcription',
            },
        ),
    ]
