# Generated by Django 3.2.14 on 2024-04-16 13:19

from django.db import migrations, models
import django.db.models.deletion


def update_existing_projects(apps, schema_editor):
    Project = apps.get_model("projects", "Project")
    AnnotationTemplate = apps.get_model("annotation_template", "AnnotationTemplate")
    db_alias = schema_editor.connection.alias
    projects = Project.objects.using(db_alias).all()

    for project in projects:
        template = (
            AnnotationTemplate.objects.using(db_alias)
            .filter(name=project.label_config_title)
            .first()
        )

        if template is None:
            continue

        project.template = template
        project.save()


class Migration(migrations.Migration):

    dependencies = [
        ("projects", "0047_project_template"),
    ]

    operations = [
        migrations.AlterField(
            model_name="project",
            name="template",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="projects",
                to="annotation_template.annotationtemplate",
            ),
        ),
        migrations.RunPython(update_existing_projects),
    ]
